#!/usr/bin/perl

#require main lib
require './myModule-lib.pl';

#print header
&header(
	$text{'index_title'}, undef, undef, undef,
	undef,                undef, undef, undef,
	'onload="redirect()"'
);
print &ui_hr();
print &ui_subheading( $text{'service_status'} );

#check all the services
$check_requirements =
  &check_packages_one_parameter( $text{'packages_requirement'} );
$check_nagios3         = &check_packages( $text{'package_nagios3'} );
$check_ndo             = &check_packages( $text{'package_ndo'} );
$check_centreon        = &check_centreon();
$check_webinstallation = &check_webinstallation();
$check_db             = &check_db();               #TODO: check
$check_nagios_running = &check_nagios_service();

#test
#$check_nagios3  = 0;
#$check_webinstallation = 0;
#$check_db = 0;

#check requirements
if ( $check_requirements == 1 ) {
	$service_requirements = "<font color='green'>$text{'installed'}</font>";
	$action_requirements  = "<font color='green'>$text{'none'}</font>";
}
else {
	$service_requirements = "<font color='red'>$text{'uninstalled'}</font>";
	$action_requirements =
"<a href=\"../software/install_pack.cgi?source=3&update=$text{'packages_requirement'}&return=../NagiosConf/index.cgi&returndesc=Nagios_Conf&caller=Nagios \"><font color='red'>$text{'install'}</font></a>";
}

#https://ubuntu-3-804-en:10000/software/install_pack.cgi?source=3&update=dhcp3%2Dserver&return=%2E%2E%2Fdhcpd%2F&returndesc=DHCP%20Server&caller=dhcpd

#check nagios3
if ( $check_nagios3 == 1 ) {
	$service_nagios = "<font color='green'>$text{'installed'}</font>";
	$action_nagios  = "<font color='green'>$text{'none'}</font>";
}
else {
	$service_nagios = "<font color='red'>$text{'uninstalled'}</font>";
	if($check_requirements == 1)
	{
		$action_nagios ="<a href=\"installnagios.cgi\"><font color='red'>$text{'install'}</font></a>";		
	}
	else
	{
		$action_nagios ="<font color='red'>$text{'waiting'}</font>";
	}
	
}

#check ndo
if ( $check_ndo == 1 ) {
	$service_ndo = "<font color='green'>$text{'installed'}</font>";
	$action_ndo  = "<font color='green'>$text{'none'}</font>";
}
else {
	$service_ndo = "<font color='red'>$text{'uninstalled'}</font>";
	if ( $check_nagios3 == 1 ) {
		$action_ndo =
"<a href=\"installndo.cgi\"><font color='red'>$text{'install'}</font></a>";
	}
	else {
		$action_ndo = "<font color='red'>$text{'waiting'}</font>";
	}

}

#check centreon
if ( $check_centreon == 1 ) {
	$service_centreon = "<font color='green'>$text{'installed'}</font>";
	$action_centreon  = "<font color='green'>$text{'none'}</font>";
}
else {
	$service_centreon = "<font color='red'>$text{'uninstalled'}</font>";
	if ( $check_ndo == 1 ) {
		$action_centreon =
"<a href=\"installcentreon.cgi\"><font color='red'>$text{'install'}</font></a>";
	}
	else {
		$action_centreon = "<font color='red'>$text{'waiting'}</font>";
	}

}

#check web installation
if ( $check_webinstallation == 1 ) 
{
	$service_webinstallation = "<font color='green'>$text{'installed'}</font>";
	$action_webinstallation  = "<font color='green'>$text{'none'}</font>";
}
else {
	$service_webinstallation = "<font color='red'>$text{'uninstalled'}</font>";
	if ( $check_centreon == 1 ) {
		$action_webinstallation =
"<a id=\"webinstall\" href=\"http://localhost/centreon/\"><font color='red'>$text{'install'}</font></a>";
		$action_webinstallation .= "<script language=\"javascript\">var link = document.getElementById(\"webinstall\");link.href=\"http://\" + window.location.hostname + \"/centreon/\";</script>";
	}
	else {
		$action_webinstallation = "<font color='red'>$text{'waiting'}</font>";
	}

}

#check DB
if ( $check_db == 1 ) {
	$service_db = "<font color='green'>$text{'installed'}</font>";
	$action_db  = "<font color='green'>$text{'none'}</font>";
}
else {
	$service_db = "<font color='red'>$text{'uninstalled'}</font>";
	if ( $check_webinstallation == 1 ) {
		$action_db =
"<a href=\"changedb.cgi\"><font color='red'>$text{'install'}</font></a>";
	}
	else {
		$action_db = "<font color='red'>$text{'waiting'}</font>";
	}

}

#check_nagios_running
if ( $check_nagios_running == 1 ) {

	#running
	$nagios_service_running = "<font color='green'>$text{'running'}</font>";
	$action_nagios_service_running = "<font color='green'>$text{'none'}</font>";
}
else {

	#not running
	$nagios_service_running = "<font color='red'>$text{'stop'}</font>";
	if ( $check_php == 1 ) {
		$action_nagios_service_running =
"<a href=\"start_nagios.cgi\"><font color='red'>$text{'start'}</font></a>";
	}
	else {
		$action_nagios_service_running =
		  "<font color='red'>$text{'waiting'}</font>";
	}

}

#start a table
print &ui_columns_start(
	[
		$text{'column_services'}, $text{'column_status'}, $text{'column_action'}
	],
	"70", 0,
	[ "width=33%", "width=33%", "width=34%" ]
);

#rows of table
$service_text = "$text{'service_nagios'} Service";
@requirements =
  [ $text{'service_requirements'}, $service_requirements,
	$action_requirements ];
@nagios3  = [ $text{'service_nagios'},   $service_nagios,   $action_nagios ];
@ndo      = [ $text{'service_ndo'},      $service_ndo,      $action_ndo ];
@centreon = [ $text{'service_centreon'}, $service_centreon, $action_centreon ];
@webinstallation = [
	$text{'service_webinstallation'}, $service_webinstallation,
	$action_webinstallation
];
@db = [ $text{'service_db'}, $service_db, $action_db ];
@service_status =
  [ $service_text, $nagios_service_running, $action_nagios_service_running ];

print &ui_columns_row(@requirements);
print &ui_columns_row(@nagios3);
print &ui_columns_row(@ndo);
print &ui_columns_row(@centreon);
print &ui_columns_row(@webinstallation);
print &ui_columns_row(@db);
print &ui_columns_row(@service_status);

#end a table
print &ui_columns_end();

print "<br>", &ui_hr();

#############################
#nagios configuration part
############################

#print subheading
print &ui_subheading( $text{'index_title'} );

#start a form
$result =
  $check_requirements +
  $check_nagios3 +
  $check_ndo +
  $check_centreon +
  $check_webinstallation +
  $check_db +
  $check_nagios_running;

print &ui_form_start( "http://localhost/centreon/", "get" );

if ( $result ne 7 ) {
	print &ui_submit( $text{'button_config'} ,"submit", 1);

}
else
{
	print &ui_submit( $text{'button_config'} );
}

#change link of form
print "<script language=\"javascript\">var form = document.getElementsByTagName(\"form\")[0];form.action=\"http://\" + window.location.hostname + \"/centreon/\";</script>";


print &ui_form_end();

&footer( "index.cgi", $text{'link_index'} );

